org.apache.xerces.impl.xs.opti

## Class DefaultNode

- java.lang.Object
- - org.apache.xerces.impl.xs.opti.DefaultNode

- All Implemented Interfaces:
    org.w3c.dom.Node
  Direct Known Subclasses:
    NodeImpl

      public class DefaultNode
      extends java.lang.Object
      implements org.w3c.dom.Node

  Version:
    $Id: DefaultNode.java 699902 2008-09-28 21:40:49Z mrglavas $
  Author:
    Rahul Srivastava, Sun Microsystems Inc.

  # INTERNAL:

    Usage of this class is not supported. It may be altered or removed at any time.

- - ### Field Summary

    - ### Fields inherited from interface org.w3c.dom.Node

      `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultNode()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `org.w3c.dom.Node` | `appendChild(org.w3c.dom.Node newChild)` Adds the node `newChild` to the end of the list of children of this node.
    `org.w3c.dom.Node` | `cloneNode(boolean deep)` Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes.
    `short` | `compareDocumentPosition(org.w3c.dom.Node other)` Compares the reference node, i.e.
    `org.w3c.dom.NamedNodeMap` | `getAttributes()` A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.
    `java.lang.String` | `getBaseURI()` DOM Level 3
    `org.w3c.dom.NodeList` | `getChildNodes()` A `NodeList` that contains all children of this node.
    `java.lang.Object` | `getFeature(java.lang.String feature, java.lang.String version)` This method returns a specialized object which implements the specialized APIs of the specified feature and version, as specified in .
    `org.w3c.dom.Node` | `getFirstChild()` The first child of this node.
    `org.w3c.dom.Node` | `getLastChild()` The last child of this node.
    `java.lang.String` | `getLocalName()` Returns the local part of the qualified name of this node.
    `java.lang.String` | `getNamespaceURI()` The namespace URI of this node, or `null` if it is unspecified (see ).
    `org.w3c.dom.Node` | `getNextSibling()` The node immediately following this node.
    `java.lang.String` | `getNodeName()` The name of this node, depending on its type; see the table above.
    `short` | `getNodeType()` A code representing the type of the underlying object, as defined above.
    `java.lang.String` | `getNodeValue()` The value of this node, depending on its type; see the table above.
    `org.w3c.dom.Document` | `getOwnerDocument()` The `Document` object associated with this node.
    `org.w3c.dom.Node` | `getParentNode()` The parent of this node.
    `java.lang.String` | `getPrefix()` The namespace prefix of this node, or `null` if it is unspecified.
    `org.w3c.dom.Node` | `getPreviousSibling()` The node immediately preceding this node.
    `java.lang.String` | `getTextContent()` This attribute returns the text content of this node and its descendants.
    `java.lang.Object` | `getUserData(java.lang.String key)` Retrieves the object associated to a key on a this node.
    `boolean` | `hasAttributes()` Returns whether this node (if it is an element) has any attributes.
    `boolean` | `hasChildNodes()` Returns whether this node has any children.
    `org.w3c.dom.Node` | `insertBefore(org.w3c.dom.Node newChild, org.w3c.dom.Node refChild)` Inserts the node `newChild` before the existing child node `refChild`.
    `boolean` | `isDefaultNamespace(java.lang.String namespaceURI)` This method checks if the specified `namespaceURI` is the default namespace or not.
    `boolean` | `isEqualNode(org.w3c.dom.Node arg)` Tests whether two nodes are equal.
    `boolean` | `isSameNode(org.w3c.dom.Node other)` Returns whether this node is the same node as the given one.
    `boolean` | `isSupported(java.lang.String feature, java.lang.String version)` Tests whether the DOM implementation implements a specific feature and that feature is supported by this node, as specified in .
    `java.lang.String` | `lookupNamespaceURI(java.lang.String prefix)` Look up the namespace URI associated to the given prefix, starting from this node.
    `java.lang.String` | `lookupPrefix(java.lang.String namespaceURI)` Look up the prefix associated to the given namespace URI, starting from this node.
    `void` | `normalize()` Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only structure (e.g., elements, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are neither adjacent `Text` nodes nor empty `Text` nodes.
    `org.w3c.dom.Node` | `removeChild(org.w3c.dom.Node oldChild)` Removes the child node indicated by `oldChild` from the list of children, and returns it.
    `org.w3c.dom.Node` | `replaceChild(org.w3c.dom.Node newChild, org.w3c.dom.Node oldChild)` Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.
    `void` | `setNodeValue(java.lang.String nodeValue)` The value of this node, depending on its type; see the table above.
    `void` | `setPrefix(java.lang.String prefix)` The namespace prefix of this node, or `null` if it is unspecified.
    `void` | `setTextContent(java.lang.String textContent)` This attribute returns the text content of this node and its descendants.
    `java.lang.Object` | `setUserData(java.lang.String key, java.lang.Object data, org.w3c.dom.UserDataHandler handler)` Associate an object to a key on this node.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultNode

          public DefaultNode()

  - ### Method Detail

    - #### getNodeName

          public java.lang.String getNodeName()

      Description copied from interface: `org.w3c.dom.Node`
      The name of this node, depending on its type; see the table above.
      Specified by:
        `getNodeName` in interface `org.w3c.dom.Node`

    - #### getNodeValue

          public java.lang.String getNodeValue()
                                        throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Node`
      The value of this node, depending on its type; see the table above. When it is defined to be `null`, setting it has no effect, including if the node is read-only.
      Specified by:
        `getNodeValue` in interface `org.w3c.dom.Node`
      Throws:
        `org.w3c.dom.DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.

    - #### getNodeType

          public short getNodeType()

      Description copied from interface: `org.w3c.dom.Node`
      A code representing the type of the underlying object, as defined above.
      Specified by:
        `getNodeType` in interface `org.w3c.dom.Node`

    - #### getParentNode

          public org.w3c.dom.Node getParentNode()

      Description copied from interface: `org.w3c.dom.Node`
      The parent of this node. All nodes, except `Attr`, `Document`, `DocumentFragment`, `Entity`, and `Notation` may have a parent. However, if a node has just been created and not yet added to the tree, or if it has been removed from the tree, this is `null`.
      Specified by:
        `getParentNode` in interface `org.w3c.dom.Node`

    - #### getChildNodes

          public org.w3c.dom.NodeList getChildNodes()

      Description copied from interface: `org.w3c.dom.Node`
      A `NodeList` that contains all children of this node. If there are no children, this is a `NodeList` containing no nodes.
      Specified by:
        `getChildNodes` in interface `org.w3c.dom.Node`

    - #### getFirstChild

          public org.w3c.dom.Node getFirstChild()

      Description copied from interface: `org.w3c.dom.Node`
      The first child of this node. If there is no such node, this returns `null`.
      Specified by:
        `getFirstChild` in interface `org.w3c.dom.Node`

    - #### getLastChild

          public org.w3c.dom.Node getLastChild()

      Description copied from interface: `org.w3c.dom.Node`
      The last child of this node. If there is no such node, this returns `null`.
      Specified by:
        `getLastChild` in interface `org.w3c.dom.Node`

    - #### getPreviousSibling

          public org.w3c.dom.Node getPreviousSibling()

      Description copied from interface: `org.w3c.dom.Node`
      The node immediately preceding this node. If there is no such node, this returns `null`.
      Specified by:
        `getPreviousSibling` in interface `org.w3c.dom.Node`

    - #### getNextSibling

          public org.w3c.dom.Node getNextSibling()

      Description copied from interface: `org.w3c.dom.Node`
      The node immediately following this node. If there is no such node, this returns `null`.
      Specified by:
        `getNextSibling` in interface `org.w3c.dom.Node`

    - #### getAttributes

          public org.w3c.dom.NamedNodeMap getAttributes()

      Description copied from interface: `org.w3c.dom.Node`
      A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.
      Specified by:
        `getAttributes` in interface `org.w3c.dom.Node`

    - #### getOwnerDocument

          public org.w3c.dom.Document getOwnerDocument()

      Description copied from interface: `org.w3c.dom.Node`
      The `Document` object associated with this node. This is also the `Document` object used to create new nodes. When this node is a `Document` or a `DocumentType` which is not used with any `Document` yet, this is `null`.
      Specified by:
        `getOwnerDocument` in interface `org.w3c.dom.Node`

    - #### hasChildNodes

          public boolean hasChildNodes()

      Description copied from interface: `org.w3c.dom.Node`
      Returns whether this node has any children.
      Specified by:
        `hasChildNodes` in interface `org.w3c.dom.Node`
      Returns:
        Returns `true` if this node has any children, `false` otherwise.

    - #### cloneNode

          public org.w3c.dom.Node cloneNode(boolean deep)

      Description copied from interface: `org.w3c.dom.Node`
      Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes. The duplicate node has no parent ( `parentNode` is `null`) and no user data. User data associated to the imported node is not carried over. However, if any `UserDataHandlers` has been specified along with the associated data these handlers will be called with the appropriate parameters before this method returns.
      Cloning an `Element` copies all attributes and their values, including those generated by the XML processor to represent defaulted attributes, but this method does not copy any children it contains unless it is a deep clone. This includes text contained in an the `Element` since the text is contained in a child `Text` node. Cloning an `Attr` directly, as opposed to be cloned as part of an `Element` cloning operation, returns a specified attribute (`specified` is `true`). Cloning an `Attr` always clones its children, since they represent its value, no matter whether this is a deep clone or not. Cloning an `EntityReference` automatically constructs its subtree if a corresponding `Entity` is available, no matter whether this is a deep clone or not. Cloning any other type of node simply returns a copy of this node.
      Note that cloning an immutable subtree results in a mutable copy, but the children of an `EntityReference` clone are readonly . In addition, clones of unspecified `Attr` nodes are specified. And, cloning `Document`, `DocumentType`, `Entity`, and `Notation` nodes is implementation dependent.
      Specified by:
        `cloneNode` in interface `org.w3c.dom.Node`
      Parameters:
        `deep` - If `true`, recursively clone the subtree under the specified node; if `false`, clone only the node itself (and its attributes, if it is an `Element`).
      Returns:
        The duplicate node.

    - #### normalize

          public void normalize()

      Description copied from interface: `org.w3c.dom.Node`
      Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only structure (e.g., elements, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are neither adjacent `Text` nodes nor empty `Text` nodes. This can be used to ensure that the DOM view of a document is the same as if it were saved and re-loaded, and is useful when operations (such as XPointer [XPointer] lookups) that depend on a particular document tree structure are to be used. If the parameter "normalize-characters" of the `DOMConfiguration` object attached to the `Node.ownerDocument` is `true`, this method will also fully normalize the characters of the `Text` nodes.

      Note: In cases where the document contains `CDATASections`, the normalize operation alone may not be sufficient, since XPointers do not differentiate between `Text` nodes and `CDATASection` nodes.

      Specified by:
        `normalize` in interface `org.w3c.dom.Node`

    - #### isSupported

          public boolean isSupported(java.lang.String feature,
                            java.lang.String version)

      Description copied from interface: `org.w3c.dom.Node`
      Tests whether the DOM implementation implements a specific feature and that feature is supported by this node, as specified in .
      Specified by:
        `isSupported` in interface `org.w3c.dom.Node`
      Parameters:
        `feature` - The name of the feature to test.
        `version` - This is the version number of the feature to test.
      Returns:
        Returns `true` if the specified feature is supported on this node, `false` otherwise.

    - #### getNamespaceURI

          public java.lang.String getNamespaceURI()

      Description copied from interface: `org.w3c.dom.Node`
      The namespace URI of this node, or `null` if it is unspecified (see ).
      This is not a computed value that is the result of a namespace lookup based on an examination of the namespace declarations in scope. It is merely the namespace URI given at creation time.
      For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `Document.createElement()`, this is always `null`.

      Note: Per the Namespaces in XML Specification [XML Namespaces] an attribute does not inherit its namespace from the element it is attached to. If an attribute is not explicitly given a namespace, it simply has no namespace.

      Specified by:
        `getNamespaceURI` in interface `org.w3c.dom.Node`

    - #### getPrefix

          public java.lang.String getPrefix()

      Description copied from interface: `org.w3c.dom.Node`
      The namespace prefix of this node, or `null` if it is unspecified. When it is defined to be `null`, setting it has no effect, including if the node is read-only.
      Note that setting this attribute, when permitted, changes the `nodeName` attribute, which holds the qualified name, as well as the `tagName` and `name` attributes of the `Element` and `Attr` interfaces, when applicable.
      Setting the prefix to `null` makes it unspecified, setting it to an empty string is implementation dependent.
      Note also that changing the prefix of an attribute that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the `namespaceURI` and `localName` do not change.
      For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`.
      Specified by:
        `getPrefix` in interface `org.w3c.dom.Node`

    - #### getLocalName

          public java.lang.String getLocalName()

      Description copied from interface: `org.w3c.dom.Node`
      Returns the local part of the qualified name of this node.
      For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `Document.createElement()`, this is always `null`.
      Specified by:
        `getLocalName` in interface `org.w3c.dom.Node`

    - #### getBaseURI

          public java.lang.String getBaseURI()

      DOM Level 3
      Specified by:
        `getBaseURI` in interface `org.w3c.dom.Node`

    - #### hasAttributes

          public boolean hasAttributes()

      Description copied from interface: `org.w3c.dom.Node`
      Returns whether this node (if it is an element) has any attributes.
      Specified by:
        `hasAttributes` in interface `org.w3c.dom.Node`
      Returns:
        Returns `true` if this node has any attributes, `false` otherwise.

    - #### setNodeValue

          public void setNodeValue(java.lang.String nodeValue)
                            throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Node`
      The value of this node, depending on its type; see the table above. When it is defined to be `null`, setting it has no effect, including if the node is read-only.
      Specified by:
        `setNodeValue` in interface `org.w3c.dom.Node`
      Throws:
        `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly and if it is not defined to be `null`.

    - #### insertBefore

          public org.w3c.dom.Node insertBefore(org.w3c.dom.Node newChild,
                                      org.w3c.dom.Node refChild)
                                        throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Node`
      Inserts the node `newChild` before the existing child node `refChild`. If `refChild` is `null`, insert `newChild` at the end of the list of children.
      If `newChild` is a `DocumentFragment` object, all of its children are inserted, in the same order, before `refChild`. If the `newChild` is already in the tree, it is first removed.

      Note: Inserting a node before itself is implementation dependent.

      Specified by:
        `insertBefore` in interface `org.w3c.dom.Node`
      Parameters:
        `newChild` - The node to insert.
        `refChild` - The reference node, i.e., the node before which the new node must be inserted.
      Returns:
        The node being inserted.
      Throws:
        `org.w3c.dom.DOMException` - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to insert is one of this node's ancestors or this node itself, or if this node is of type `Document` and the DOM application attempts to insert a second `DocumentType` or `Element` node.
        WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly or if the parent of the node being inserted is readonly.
        NOT_FOUND_ERR: Raised if `refChild` is not a child of this node.
        NOT_SUPPORTED_ERR: if this node is of type `Document`, this exception might be raised if the DOM implementation doesn't support the insertion of a `DocumentType` or `Element` node.

    - #### replaceChild

          public org.w3c.dom.Node replaceChild(org.w3c.dom.Node newChild,
                                      org.w3c.dom.Node oldChild)
                                        throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Node`
      Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.
      If `newChild` is a `DocumentFragment` object, `oldChild` is replaced by all of the `DocumentFragment` children, which are inserted in the same order. If the `newChild` is already in the tree, it is first removed.

      Note: Replacing a node with itself is implementation dependent.

      Specified by:
        `replaceChild` in interface `org.w3c.dom.Node`
      Parameters:
        `newChild` - The new node to put in the child list.
        `oldChild` - The node being replaced in the list.
      Returns:
        The node replaced.
      Throws:
        `org.w3c.dom.DOMException` - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to put in is one of this node's ancestors or this node itself, or if this node is of type `Document` and the result of the replacement operation would add a second `DocumentType` or `Element` on the `Document` node.
        WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this node or the parent of the new node is readonly.
        NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.
        NOT_SUPPORTED_ERR: if this node is of type `Document`, this exception might be raised if the DOM implementation doesn't support the replacement of the `DocumentType` child or `Element` child.

    - #### removeChild

          public org.w3c.dom.Node removeChild(org.w3c.dom.Node oldChild)
                                       throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Node`
      Removes the child node indicated by `oldChild` from the list of children, and returns it.
      Specified by:
        `removeChild` in interface `org.w3c.dom.Node`
      Parameters:
        `oldChild` - The node being removed.
      Returns:
        The node removed.
      Throws:
        `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
        NOT_FOUND_ERR: Raised if `oldChild` is not a child of this node.
        NOT_SUPPORTED_ERR: if this node is of type `Document`, this exception might be raised if the DOM implementation doesn't support the removal of the `DocumentType` child or the `Element` child.

    - #### appendChild

          public org.w3c.dom.Node appendChild(org.w3c.dom.Node newChild)
                                       throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Node`
      Adds the node `newChild` to the end of the list of children of this node. If the `newChild` is already in the tree, it is first removed.
      Specified by:
        `appendChild` in interface `org.w3c.dom.Node`
      Parameters:
        `newChild` - The node to add.If it is a `DocumentFragment` object, the entire contents of the document fragment are moved into the child list of this node
      Returns:
        The node added.
      Throws:
        `org.w3c.dom.DOMException` - HIERARCHY_REQUEST_ERR: Raised if this node is of a type that does not allow children of the type of the `newChild` node, or if the node to append is one of this node's ancestors or this node itself, or if this node is of type `Document` and the DOM application attempts to append a second `DocumentType` or `Element` node.
        WRONG_DOCUMENT_ERR: Raised if `newChild` was created from a different document than the one that created this node.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly or if the previous parent of the node being inserted is readonly.
        NOT_SUPPORTED_ERR: if the `newChild` node is a child of the `Document` node, this exception might be raised if the DOM implementation doesn't support the removal of the `DocumentType` child or `Element` child.

    - #### setPrefix

          public void setPrefix(java.lang.String prefix)
                         throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Node`
      The namespace prefix of this node, or `null` if it is unspecified. When it is defined to be `null`, setting it has no effect, including if the node is read-only.
      Note that setting this attribute, when permitted, changes the `nodeName` attribute, which holds the qualified name, as well as the `tagName` and `name` attributes of the `Element` and `Attr` interfaces, when applicable.
      Setting the prefix to `null` makes it unspecified, setting it to an empty string is implementation dependent.
      Note also that changing the prefix of an attribute that is known to have a default value, does not make a new attribute with the default value and the original prefix appear, since the `namespaceURI` and `localName` do not change.
      For nodes of any type other than `ELEMENT_NODE` and `ATTRIBUTE_NODE` and nodes created with a DOM Level 1 method, such as `createElement` from the `Document` interface, this is always `null`.
      Specified by:
        `setPrefix` in interface `org.w3c.dom.Node`
      Throws:
        `org.w3c.dom.DOMException` - INVALID_CHARACTER_ERR: Raised if the specified prefix contains an illegal character according to the XML version in use specified in the `Document.xmlVersion` attribute.
        NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.
        NAMESPACE_ERR: Raised if the specified `prefix` is malformed per the Namespaces in XML specification, if the `namespaceURI` of this node is `null`, if the specified prefix is "xml" and the `namespaceURI` of this node is different from " http://www.w3.org/XML/1998/namespace", if this node is an attribute and the specified prefix is "xmlns" and the `namespaceURI` of this node is different from "http://www.w3.org/2000/xmlns/", or if this node is an attribute and the `qualifiedName` of this node is "xmlns" [XML Namespaces] .

    - #### compareDocumentPosition

          public short compareDocumentPosition(org.w3c.dom.Node other)

      Description copied from interface: `org.w3c.dom.Node`
      Compares the reference node, i.e. the node on which this method is being called, with a node, i.e. the one passed as a parameter, with regard to their position in the document and according to the document order.
      Specified by:
        `compareDocumentPosition` in interface `org.w3c.dom.Node`
      Parameters:
        `other` - The node to compare against the reference node.
      Returns:
        Returns how the node is positioned relatively to the reference node.

    - #### getTextContent

          public java.lang.String getTextContent()
                                          throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Node`
      This attribute returns the text content of this node and its descendants. When it is defined to be `null`, setting it has no effect. On setting, any possible children this node may have are removed and, if it the new string is not empty or `null`, replaced by a single `Text` node containing the string this attribute is set to.
      On getting, no serialization is performed, the returned string does not contain any markup. No whitespace normalization is performed and the returned string does not contain the white spaces in element content (see the attribute `Text.isElementContentWhitespace`). Similarly, on setting, no parsing is performed either, the input string is taken as pure textual content.
      The string returned is made of the text content of this node depending on its type, as defined below:

      Node type | Content
      --- | ---
      ELEMENT_NODE, ATTRIBUTE_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, DOCUMENT_FRAGMENT_NODE | concatenation of the `textContent` attribute value of every child node, excluding COMMENT_NODE and PROCESSING_INSTRUCTION_NODE nodes. This is the empty string if the node has no children.
      TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE, PROCESSING_INSTRUCTION_NODE | `nodeValue`
      DOCUMENT_NODE, DOCUMENT_TYPE_NODE, NOTATION_NODE | null

      Specified by:
        `getTextContent` in interface `org.w3c.dom.Node`
      Throws:
        `org.w3c.dom.DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.

    - #### setTextContent

          public void setTextContent(java.lang.String textContent)
                              throws org.w3c.dom.DOMException

      Description copied from interface: `org.w3c.dom.Node`
      This attribute returns the text content of this node and its descendants. When it is defined to be `null`, setting it has no effect. On setting, any possible children this node may have are removed and, if it the new string is not empty or `null`, replaced by a single `Text` node containing the string this attribute is set to.
      On getting, no serialization is performed, the returned string does not contain any markup. No whitespace normalization is performed and the returned string does not contain the white spaces in element content (see the attribute `Text.isElementContentWhitespace`). Similarly, on setting, no parsing is performed either, the input string is taken as pure textual content.
      The string returned is made of the text content of this node depending on its type, as defined below:

      Node type | Content
      --- | ---
      ELEMENT_NODE, ATTRIBUTE_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, DOCUMENT_FRAGMENT_NODE | concatenation of the `textContent` attribute value of every child node, excluding COMMENT_NODE and PROCESSING_INSTRUCTION_NODE nodes. This is the empty string if the node has no children.
      TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE, PROCESSING_INSTRUCTION_NODE | `nodeValue`
      DOCUMENT_NODE, DOCUMENT_TYPE_NODE, NOTATION_NODE | null

      Specified by:
        `setTextContent` in interface `org.w3c.dom.Node`
      Throws:
        `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.

    - #### isSameNode

          public boolean isSameNode(org.w3c.dom.Node other)

      Description copied from interface: `org.w3c.dom.Node`
      Returns whether this node is the same node as the given one.
      This method provides a way to determine whether two `Node` references returned by the implementation reference the same object. When two `Node` references are references to the same object, even if through a proxy, the references may be used completely interchangeably, such that all attributes have the same values and calling the same DOM method on either reference always has exactly the same effect.
      Specified by:
        `isSameNode` in interface `org.w3c.dom.Node`
      Parameters:
        `other` - The node to test against.
      Returns:
        Returns `true` if the nodes are the same, `false` otherwise.

    - #### lookupPrefix

          public java.lang.String lookupPrefix(java.lang.String namespaceURI)

      Description copied from interface: `org.w3c.dom.Node`
      Look up the prefix associated to the given namespace URI, starting from this node. The default namespace declarations are ignored by this method.
      See for details on the algorithm used by this method.
      Specified by:
        `lookupPrefix` in interface `org.w3c.dom.Node`
      Parameters:
        `namespaceURI` - The namespace URI to look for.
      Returns:
        Returns an associated namespace prefix if found or `null` if none is found. If more than one prefix are associated to the namespace prefix, the returned namespace prefix is implementation dependent.

    - #### isDefaultNamespace

          public boolean isDefaultNamespace(java.lang.String namespaceURI)

      Description copied from interface: `org.w3c.dom.Node`
      This method checks if the specified `namespaceURI` is the default namespace or not.
      Specified by:
        `isDefaultNamespace` in interface `org.w3c.dom.Node`
      Parameters:
        `namespaceURI` - The namespace URI to look for.
      Returns:
        Returns `true` if the specified `namespaceURI` is the default namespace, `false` otherwise.

    - #### lookupNamespaceURI

          public java.lang.String lookupNamespaceURI(java.lang.String prefix)

      Description copied from interface: `org.w3c.dom.Node`
      Look up the namespace URI associated to the given prefix, starting from this node.
      See for details on the algorithm used by this method.
      Specified by:
        `lookupNamespaceURI` in interface `org.w3c.dom.Node`
      Parameters:
        `prefix` - The prefix to look for. If this parameter is `null`, the method will return the default namespace URI if any.
      Returns:
        Returns the associated namespace URI or `null` if none is found.

    - #### isEqualNode

          public boolean isEqualNode(org.w3c.dom.Node arg)

      Description copied from interface: `org.w3c.dom.Node`
      Tests whether two nodes are equal.
      This method tests for equality of nodes, not sameness (i.e., whether the two nodes are references to the same object) which can be tested with `Node.isSameNode()`. All nodes that are the same will also be equal, though the reverse may not be true.
      Two nodes are equal if and only if the following conditions are satisfied:
      - The two nodes are of the same type.
      - The following string attributes are equal: `nodeName`, `localName`, `namespaceURI`, `prefix`, `nodeValue` . This is: they are both `null`, or they have the same length and are character for character identical.
      - The `attributes` `NamedNodeMaps` are equal. This is: they are both `null`, or they have the same length and for each node that exists in one map there is a node that exists in the other map and is equal, although not necessarily at the same index.
      - The `childNodes` `NodeLists` are equal. This is: they are both `null`, or they have the same length and contain equal nodes at the same index. Note that normalization can affect equality; to avoid this, nodes should be normalized before being compared.
      For two `DocumentType` nodes to be equal, the following conditions must also be satisfied:
      - The following string attributes are equal: `publicId`, `systemId`, `internalSubset`.
      - The `entities` `NamedNodeMaps` are equal.
      - The `notations` `NamedNodeMaps` are equal.
      On the other hand, the following do not affect equality: the `ownerDocument`, `baseURI`, and `parentNode` attributes, the `specified` attribute for `Attr` nodes, the `schemaTypeInfo` attribute for `Attr` and `Element` nodes, the `Text.isElementContentWhitespace` attribute for `Text` nodes, as well as any user data or event listeners registered on the nodes.

      Note: As a general rule, anything not mentioned in the description above is not significant in consideration of equality checking. Note that future versions of this specification may take into account more attributes and implementations conform to this specification are expected to be updated accordingly.

      Specified by:
        `isEqualNode` in interface `org.w3c.dom.Node`
      Parameters:
        `arg` - The node to compare equality with.
      Returns:
        Returns `true` if the nodes are equal, `false` otherwise.

    - #### getFeature

          public java.lang.Object getFeature(java.lang.String feature,
                                    java.lang.String version)

      Description copied from interface: `org.w3c.dom.Node`
      This method returns a specialized object which implements the specialized APIs of the specified feature and version, as specified in . The specialized object may also be obtained by using binding-specific casting methods but is not necessarily expected to, as discussed in . This method also allow the implementation to provide specialized objects which do not support the `Node` interface.
      Specified by:
        `getFeature` in interface `org.w3c.dom.Node`
      Parameters:
        `feature` - The name of the feature requested. Note that any plus sign "+" prepended to the name of the feature will be ignored since it is not significant in the context of this method.
        `version` - This is the version number of the feature to test.
      Returns:
        Returns an object which implements the specialized APIs of the specified feature and version, if any, or `null` if there is no object which implements interfaces associated with that feature. If the `DOMObject` returned by this method implements the `Node` interface, it must delegate to the primary core `Node` and not return results inconsistent with the primary core `Node` such as attributes, childNodes, etc.

    - #### setUserData

          public java.lang.Object setUserData(java.lang.String key,
                                     java.lang.Object data,
                                     org.w3c.dom.UserDataHandler handler)

      Description copied from interface: `org.w3c.dom.Node`
      Associate an object to a key on this node. The object can later be retrieved from this node by calling `getUserData` with the same key.
      Specified by:
        `setUserData` in interface `org.w3c.dom.Node`
      Parameters:
        `key` - The key to associate the object to.
        `data` - The object to associate to the given key, or `null` to remove any existing association to that key.
        `handler` - The handler to associate to that key, or `null`.
      Returns:
        Returns the `DOMUserData` previously associated to the given key on this node, or `null` if there was none.

    - #### getUserData

          public java.lang.Object getUserData(java.lang.String key)

      Description copied from interface: `org.w3c.dom.Node`
      Retrieves the object associated to a key on a this node. The object must first have been set to this node by calling `setUserData` with the same key.
      Specified by:
        `getUserData` in interface `org.w3c.dom.Node`
      Parameters:
        `key` - The key the object is associated to.
      Returns:
        Returns the `DOMUserData` associated to the given key on this node, or `null` if there was none.

Copyright © 1999-2022 The Apache Software Foundation. All Rights Reserved.